#include <Arduino.h>
#include<TA1268NTSCcolorTVIC.h>
#include <IRremote.h>
#include<SN761668PLL.h>
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2); 

#define IR_pin   A4 //D0
const int RECV_PIN = IR_pin; // IR Receiver pin
IRrecv irrecv(RECV_PIN);
decode_results results;

#define clk A1
#define dta A2
int cureentclock =0;
int previceClock =0;
int d=  0x20; //0x3c;
byte add = 0x44;
int fr = 2737;
uint8_t osc =1;
int CBFraquency = 4500; // CB radio start fraquncy scan
int FM915Frequency = 17370; // 915 MHZ start fraquncy scan  17370
int TVFrequency = 2040; // tv start fraquncy scan
int FMFrequency = 2737; // fm radio start fraquncy scan
int AirPortFrequency =3385;
int frSelect =1;

void UpDateDisplay(int frd,int oscd){
  // TCA9548A(1);
  Wire.beginTransmission(0x70);  // TCA9548A address
  Wire.write(1 << 2);          // send byte to select bus
  Wire.endTransmission();
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("FM:");
  lcd.setCursor(3,0);
  lcd.print(frd);
  lcd.setCursor(0,1);
  lcd.print("OSCI:");
  lcd.setCursor(6,1);
  lcd.print(oscd);
  lcd.setCursor(10,0);
  lcd.print("AT:");
  lcd.setCursor(13,0);
  lcd.print(d);
  lcd.setCursor(8,1);
  lcd.print("RF:");
  lcd.setCursor(11,1);
  lcd.print(d);
}
void setup() {
  Serial.begin(9600);
 Wire.begin();
  irrecv.enableIRIn();
   lcd.init();                      // initialize the lcd 
  lcd.backlight();
    pinMode(clk,INPUT);
  pinMode(dta,INPUT);
   Wire.beginTransmission(0x70);  // TCA9548A address
  Wire.write(1 << 0);          // send byte to select bus
    Wire.endTransmission();
    AudioATT();
    RFAGC();
    fr = FMFrequency;
    previceClock = digitalRead(clk);

    Wire.beginTransmission(0x70);  // TCA9548A address
    Wire.write(1 << 2);          // send byte to select bus
    Wire.endTransmission();
    UpDateDisplay(fr,osc);
    /*
for(int x=0;x< 16;x++){
        Wire.beginTransmission(0x70);  // TCA9548A address
        Wire.write(1 << 0);          // send byte to select bus
        Wire.endTransmission();
        FunctionLookUp[x](0x3f);
        delay(10);
       }
       */
        //d++;
        //Serial.print(d);
}

void loop() {

cureentclock = digitalRead(clk);
if(cureentclock != previceClock){
  if(cureentclock != digitalRead(dta)){
   fr--;
SNTVTuner(fr,osc);
  }
  else{
   fr++;
 SNTVTuner(fr,osc);
  }
     UpDateDisplay(fr,osc);
}
previceClock = cureentclock;

  if(irrecv.decode(&results)){
     switch (results.value)
      {
        case 3772778233: // up button for osc select
        SNTVTuner(fr,osc);
        osc++;
        if(osc >5)osc=5;
        break;
        case 3772810873: // up button for osc select
       SNTVTuner(fr,osc);
        osc--;
        if(osc<=1)osc=1;
        break;
         case 3772795063:  //channel up
        SNTVTuner(fr,osc);
        fr++;
        break;
        case 3772778743: // channel down
        SNTVTuner(fr,osc);
        fr--;
        break;
        case 3772794553: // right button for frq select
        frSelect++;
        if(frSelect ==1) fr = FMFrequency;
        if(frSelect ==2)  fr = AirPortFrequency;
        if(frSelect ==3) fr =FM915Frequency;
        if(frSelect ==4) fr = TVFrequency;
        if(frSelect ==5) fr = CBFraquency;
        if(frSelect >5)frSelect=5;
        SNTVTuner(fr,osc);
        break;
        case 3772819033: //left button for frq select
        frSelect--;
        if(frSelect ==1) fr = FMFrequency;
        if(frSelect ==2) fr = AirPortFrequency;
        if(frSelect ==3)  fr =FM915Frequency;
        if(frSelect ==4) fr = TVFrequency;
        if(frSelect ==5) fr = CBFraquency;
        if(frSelect <=1)frSelect=1;
        SNTVTuner(fr,osc);
        break;
        case 3772802968:
        Wire.beginTransmission(0x70);  // TCA9548A address
        Wire.write(1 << 0);          // send byte to select bus
        Wire.endTransmission();
        RFAGC(d);
        //PIFVCO(d);
        //AudioATT(d);
        d++;
        if(d>255)d=64;
        break;
        case 3772809343:
        Wire.beginTransmission(0x70);  // TCA9548A address
        Wire.write(1 << 0);          // send byte to select bus
        Wire.endTransmission();
       RFAGC(d);
       //PIFVCO(d);
       //AudioATT(d);
        d--;
        if(d<=0)d=1;
        break;
        case 3772817503:
       for(int x=0;x< 16;x++){
        Wire.beginTransmission(0x70);  // TCA9548A address
        Wire.write(1 << 0);          // send byte to select bus
        Wire.endTransmission();
        FunctionLookUp[x](0x3f);
        delay(10);
       }
        
        break;
         case 484667535:  //channel up
        SNTVTuner(fr,osc);
        fr++;
        break;
        case 484700175: // channel down
        SNTVTuner(fr,osc);
        fr--;
        break;
      }
    UpDateDisplay(fr,osc);
  }
   irrecv.resume();
}

